Attribute VB_Name = "otlcb95bas"
Option Explicit
Option Base 1

'OTL variables
Public Type OtlSetup 'one per outline
    Levels As Integer
    VariableNames(5) As String 'Max 5 levels
    BmpField As String 'field holding bitmap to use for leafs if not use default
    CheckmarkField As String 'field to examine to determine if record is selected
    BmpFlag As Integer
    LineFlag As Integer
    PlusFlag As Integer
    CheckmarkFlag As Integer
    DisplayLines As Integer
    DisplayIdx(100) As Integer 'Max 100 lines visible
    DisplayCount As Integer 'virtual Ubound of displayidx
    VisibleItems As Integer
    VisChangeFlag As Integer
    LineHeight As Integer 'Twips
    ColWidth As Integer 'twips
    ElementClicked As Integer
    SelectColor As Long 'RGB
    SelectTextColor As Long
    FontName As String
    FontColor As Long
    Fontsize As Single
    TopIdx As Integer
    SelectIdx As Integer
    CurrentLine As Integer
    PrevTop As Integer
    PrevSel As Integer
    LastType As Integer     ' 0=None, 1=Parent, 2=Collapse, 3=Expand, 4=Child, Last clicked or keypress
End Type

Public Type OtlData  'Use in array
    Caption As String
    Level As Integer
    Visible As Integer
    Expanded As Integer
    VisibleIdx As Long
    Bookmark As String
    BmpFileName As String 'if not use default
    Selected As Integer '0-none, 1-all, 2-some
    SyncIdx As Integer 'Optional, sync to another array
    ItemData As Long
    IsParent As Boolean 'is this a parent
End Type

'standard images
Global gBranchOpenPic As Control
Global gBranchClosedPic As Control
Global gLeafPic As Control
Global gCustomPic As Control
Global gPlusPic As Control
Global gMinusPic As Control
'checked images
Global gBranchOpenAllPic As Control 'checked
Global gBranchClosedAllPic As Control
Global gBranchOpenSomePic As Control
Global gBranchClosedSomePic As Control
Global gLeafCheckedPic As Control
Dim ChangingScroll As Integer
'KeyCodes Constants
Const KEY_PRIOR = &H21
Const KEY_NEXT = &H22
Const KEY_END = &H23
Const KEY_HOME = &H24
Const KEY_LEFT = &H25
Const KEY_UP = &H26
Const KEY_RIGHT = &H27
Const KEY_DOWN = &H28
Const KEY_ADD = &H6B
Const KEY_SUBTRACT = &H6D
#If Win32 Then
    Declare Function BitBlt Lib "gdi32" (ByVal hDestDC%, ByVal x%, ByVal y%, ByVal nWidth%, ByVal nHeight%, ByVal hSrcDC%, ByVal xSrc%, ByVal ySrc%, ByVal dwRop&) As Integer
    Declare Function StretchBlt Lib "gdi32" (ByVal hDestDC%, ByVal x%, ByVal y%, ByVal nWidth%, ByVal nHeight%, ByVal hSrcDC%, ByVal xSrc%, ByVal ySrc%, ByVal nsrcWidth%, ByVal nsrcHeight%, ByVal dwRop&) As Integer
    Declare Function SetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
#Else
    Declare Function BitBlt Lib "GDI" (ByVal hDestDC%, ByVal x%, ByVal y%, ByVal nWidth%, ByVal nHeight%, ByVal hSrcDC%, ByVal xSrc%, ByVal ySrc%, ByVal dwRop&) As Integer
    Declare Function StretchBlt Lib "GDI" (ByVal hDestDC%, ByVal x%, ByVal y%, ByVal nWidth%, ByVal nHeight%, ByVal hSrcDC%, ByVal xSrc%, ByVal ySrc%, ByVal nsrcWidth%, ByVal nsrcHeight%, ByVal dwRop&) As Integer
    Declare Function SetPixel Lib "GDI" (ByVal hDC As Integer, ByVal x As Integer, ByVal y As Integer, ByVal crColor As Long) As Long
#End If

'Establishes the Bitmap objects for an outline control
'Sub OutlineBmpSetup(BranchOpen As Control, BoFile As String, BranchClosed As Control, BcFile As String, Leaf As Control, LFile As String, CustomPic As Control)
'On Error Resume Next
'
'Set gBranchOpenPic = IIf(m_PictureOpen = Nothing, BranchOpen, m_PictureOpen)
'Set gBranchClosedPic = IIf(m_PictureClosed = Nothing, BranchClosed, m_PictureClosed)
'Set gLeafPic = IIf(m_PictureItemNotSelected = Nothing, Leaf, m_PictureItemNotSelected)
'Set gCustomPic = IIf(m_PictureItemNotSelected = Nothing, CustomPic, m_PictureItemNotSelected)
'
'If BoFile > "" Then gBranchOpenPic.Picture = LoadPicture(BoFile)
'If BcFile > "" Then gBranchClosedPic.Picture = LoadPicture(BcFile)
'If LFile > "" Then gLeafPic.Picture = LoadPicture(LFile)
'
'End Sub
Sub OutlineBmpSetup(BranchOpen As Control, BoPic As Picture, BranchClosed As Control, BcPic As Picture, Leaf As Control, LPic As Picture, CustomPic As Control, CPic As Picture)
On Error Resume Next

Set gBranchOpenPic = BranchOpen
Set gBranchClosedPic = BranchClosed
Set gLeafPic = Leaf
Set gCustomPic = CustomPic

If Not BoPic Is Nothing Then gBranchOpenPic.Picture = BoPic
If Not BcPic Is Nothing Then gBranchClosedPic.Picture = BcPic
If Not LPic Is Nothing Then gLeafPic.Picture = LPic
If Not CPic Is Nothing Then gCustomPic.Picture = CPic

End Sub

Sub OutlineBmpCheckedSetup(BranchOpenAll As Control, BoaPic As Picture, BranchClosedAll As Control, BcaPic As Picture, BranchOpenSome As Control, BosPic As Picture, BranchClosedSome As Control, BcsPic As Picture, LeafChecked As Control, LcPic As Picture)
'On Error Resume Next

Set gBranchOpenAllPic = BranchOpenAll
Set gBranchClosedAllPic = BranchClosedAll
Set gBranchOpenSomePic = BranchOpenSome
Set gBranchClosedSomePic = BranchClosedSome
Set gLeafCheckedPic = LeafChecked

If Not BoaPic Is Nothing Then gBranchOpenAllPic.Picture = BoaPic
If Not BcaPic Is Nothing Then gBranchClosedAllPic.Picture = BcaPic
If Not BosPic Is Nothing Then gBranchOpenSomePic.Picture = BosPic
If Not BcsPic Is Nothing Then gBranchClosedSomePic.Picture = BcsPic
If Not LcPic Is Nothing Then gLeafCheckedPic.Picture = LcPic


End Sub


'Processes a mouse click.
Sub OutlineClick(OtlPic As Control, OtlScroll As Control, Otlset As OtlSetup, OtlDat As Collection)
Dim foo As Integer
Dim Children As Integer

'set select
Otlset.LastType = 0
If Otlset.CurrentLine > Otlset.DisplayCount Then Exit Sub

'default as child click, but change later if parent
Otlset.LastType = IIf(Otlset.ElementClicked > 0, 4, 0)

If Otlset.ElementClicked > 0 Then Otlset.SelectIdx = Otlset.DisplayIdx(Otlset.CurrentLine)
'OtlSet.SelectIdx = OtlSet.DisplayIdx(OtlSet.CurrentLine)

'if pictureclick then select all or deselect all, don't expand
If Otlset.ElementClicked = 1 And Otlset.CheckmarkFlag Then
  If OtlDat(Otlset.DisplayIdx(Otlset.CurrentLine)).IsParent Then
    Otlset.LastType = 1
  Else
    Otlset.LastType = 4
  End If
  Otlset.VisChangeFlag = True
  If OtlDat(Otlset.DisplayIdx(Otlset.CurrentLine)).Selected = 1 Then
    OtlDat(Otlset.DisplayIdx(Otlset.CurrentLine)).Selected = 0
  Else
    OtlDat(Otlset.DisplayIdx(Otlset.CurrentLine)).Selected = 1
  End If

  'set child select
  For foo = Otlset.DisplayIdx(Otlset.CurrentLine) + 1 To OtlDat.Count
    If OtlDat(foo).Level <= OtlDat(Otlset.DisplayIdx(Otlset.CurrentLine)).Level Then Exit For
    OtlDat(foo).Selected = OtlDat(Otlset.DisplayIdx(Otlset.CurrentLine)).Selected
  Next foo
  'set parent selects
  CheckMarkParents Otlset, OtlDat
Else
  'is it a branch?
  'If OtlDat(OtlSet.DisplayIdx(OtlSet.CurrentLine)).Level < OtlSet.Levels - 1 Then
  If OtlDat(Otlset.DisplayIdx(Otlset.CurrentLine)).IsParent Then
  
      Otlset.VisChangeFlag = True
      'was it expanded?
      If OtlDat(Otlset.DisplayIdx(Otlset.CurrentLine)).Expanded = True Then
          'Collapse children
          Otlset.LastType = 2
          For foo = Otlset.DisplayIdx(Otlset.CurrentLine) + 1 To OtlDat.Count
              If OtlDat(foo).Level <= OtlDat(Otlset.DisplayIdx(Otlset.CurrentLine)).Level Then Exit For
              OtlDat(foo).Expanded = False
              OtlDat(foo).Visible = False
          Next foo
      Else
          'Expand next level
          Otlset.LastType = 3
          Children = 0
          For foo = Otlset.DisplayIdx(Otlset.CurrentLine) + 1 To OtlDat.Count
              If OtlDat(foo).Level <= OtlDat(Otlset.DisplayIdx(Otlset.CurrentLine)).Level Then
                  Exit For
              Else
                  If OtlDat(foo).Level = OtlDat(Otlset.DisplayIdx(Otlset.CurrentLine)).Level + 1 Then
                      OtlDat(foo).Expanded = False
                      OtlDat(foo).Visible = True
                      Children = Children + 1
                  End If
              End If
          Next foo
      End If
      OtlDat(Otlset.DisplayIdx(Otlset.CurrentLine)).Expanded = Not OtlDat(Otlset.DisplayIdx(Otlset.CurrentLine)).Expanded
      If Children + Otlset.CurrentLine >= Otlset.DisplayLines Then
        If Children < Otlset.DisplayLines Then
          Otlset.TopIdx = Otlset.DisplayIdx((Otlset.CurrentLine + Children + 1) - Otlset.DisplayLines)
          Otlset.SelectIdx = Otlset.DisplayIdx(Otlset.CurrentLine)
          Otlset.CurrentLine = Otlset.CurrentLine - (Children + 1)
        Else
          Otlset.TopIdx = Otlset.DisplayIdx(Otlset.CurrentLine)
          Otlset.SelectIdx = Otlset.DisplayIdx(Otlset.CurrentLine)
          Otlset.CurrentLine = 1
        End If
          
      End If
     
  End If
End If
OutlineRefresh OtlPic, OtlScroll, Otlset, OtlDat

End Sub

Public Sub CheckMarkParents(Otlset As OtlSetup, OtlDat As Collection)
Dim foo As Integer
ReDim LevelValue(Otlset.Levels) As Double
ReDim levelcount(Otlset.Levels) As Integer
For foo = OtlDat.Count To 1 Step -1
  'handle control break if this is not a child
'  If OtlDat(foo).Level <= OtlSet.Levels - 2 Then
  If OtlDat(foo).IsParent Then
    If LevelValue(OtlDat(foo).Level + 1) = 0 Then
      OtlDat(foo).Selected = 0  'none selected
    Else
      If levelcount(OtlDat(foo).Level + 1) = LevelValue(OtlDat(foo).Level + 1) Then
        OtlDat(foo).Selected = 1  'all selected
      Else
        OtlDat(foo).Selected = 2  'some selected
      End If
    End If
    LevelValue(OtlDat(foo).Level + 1) = 0
    levelcount(OtlDat(foo).Level + 1) = 0
  End If
  If OtlDat(foo).Level > 0 Then
    'increment parent count
    Select Case OtlDat(foo).Selected
    Case 1
      LevelValue(OtlDat(foo).Level) = LevelValue(OtlDat(foo).Level) + 1
    Case 2
      LevelValue(OtlDat(foo).Level) = LevelValue(OtlDat(foo).Level) + 0.0001
    End Select
    levelcount(OtlDat(foo).Level) = levelcount(OtlDat(foo).Level) + 1
    
  End If
Next foo
End Sub

'Closes all open branches.

Sub OutlineCollapseAll(OtlPic As Control, OtlScroll As Control, Otlset As OtlSetup, OtlDat As Collection)
Dim foo As Integer
Dim TotVisible As Integer
For foo = 1 To OtlDat.Count
    If OtlDat(foo).Level > 0 Then
        OtlDat(foo).Visible = False
        OtlDat(foo).Expanded = False
    Else
        OtlDat(foo).Expanded = False
    End If
    If OtlDat(foo).Visible = True Then TotVisible = TotVisible + 1
Next foo
If OtlDat(Otlset.SelectIdx).Visible = False Then Otlset.SelectIdx = 0
If TotVisible <= Otlset.DisplayLines Then
  Otlset.TopIdx = 1
Else
  Otlset.TopIdx = Otlset.SelectIdx
End If
Otlset.VisChangeFlag = True

OutlineRefresh OtlPic, OtlScroll, Otlset, OtlDat

End Sub


'Opens all branches.

Sub OutlineExpandAll(OtlPic As Control, OtlScroll As Control, Otlset As OtlSetup, OtlDat As Collection)
Dim foo As Integer

For foo = 1 To OtlDat.Count
    OtlDat(foo).Visible = True
    'If OtlDat(foo).Level < OtlSet.Levels - 1 Then OtlDat(foo).Expanded = True
    If OtlDat(foo).IsParent Then OtlDat(foo).Expanded = True
Next foo
Otlset.VisChangeFlag = True

OutlineRefresh OtlPic, OtlScroll, Otlset, OtlDat

End Sub


'Locates text within the control.

Sub OutlineFind(FindItem As String, FindMode As Integer, OtlPic As Control, OtlScroll As Control, Otlset As OtlSetup, OtlDat As Collection)
Dim ItemStart As Integer, foo As Integer, foobar As Integer
Dim foo2 As Integer
If FindMode = 0 Then
    ItemStart = 1
Else
    ItemStart = Otlset.SelectIdx + 1
End If
For foo = ItemStart To OtlDat.Count
    If InStr(1, OtlDat(foo).Caption, FindItem, 1) > 0 Then
        Otlset.SelectIdx = foo
        Otlset.TopIdx = foo
        If OtlDat(foo).Level <> 0 Then
            For foobar = foo To 1 Step -1
                If OtlDat(foobar).Level = 0 Then
                    OtlDat(foobar).Expanded = True
                    OtlDat(foobar).Visible = True
                    Exit For
                End If
            Next foobar
            For foo2 = foobar + 1 To OtlDat.Count
                If OtlDat(foo2).Level = 0 Then Exit For
                OtlDat(foo2).Visible = True
            Next foo2
        End If
        Otlset.CurrentLine = 1
        Otlset.VisChangeFlag = True
        OutlineRefresh OtlPic, OtlScroll, Otlset, OtlDat
        Exit Sub
    End If
Next foo
'item not found
Beep

End Sub


'Processes outline control keys

Sub OutlineKeyPress(KeyCode As Integer, OtlPic As Control, OtlScroll As Control, Otlset As OtlSetup, OtlDat As Collection)
Dim foo As Integer, VisCount As Integer
On Error Resume Next
Select Case KeyCode
Case KEY_ADD      '+ from numeric keypad
    'If OtlDat(OtlSet.SelectIdx).Level < OtlSet.Levels - 1 And OtlDat(OtlSet.SelectIdx).Expanded = False Then
    If OtlDat(Otlset.SelectIdx).IsParent And OtlDat(Otlset.SelectIdx).Expanded = False Then
        OutlineClick OtlPic, OtlScroll, Otlset, OtlDat
    End If
Case KEY_SUBTRACT '- from numeric keypad
    'If OtlDat(OtlSet.SelectIdx).Level < OtlSet.Levels - 1 And OtlDat(OtlSet.SelectIdx).Expanded = True Then
    If OtlDat(Otlset.SelectIdx).IsParent And OtlDat(Otlset.SelectIdx).Expanded = True Then
        OutlineClick OtlPic, OtlScroll, Otlset, OtlDat
    End If
Case KEY_PRIOR
    VisCount = 0
    foo = 0
    For foo = Otlset.TopIdx To 1 Step -1
        If OtlDat(foo).Visible = True Then VisCount = VisCount + 1
        If VisCount = Otlset.DisplayLines Then Exit For
    Next foo
    Otlset.CurrentLine = 1
    Otlset.TopIdx = foo
    Otlset.SelectIdx = Otlset.TopIdx
    OutlineRefresh OtlPic, OtlScroll, Otlset, OtlDat
Case KEY_NEXT
    For foo = Otlset.DisplayLines To 1 Step -1
        If Otlset.DisplayIdx(foo) > 0 Then
            Otlset.TopIdx = Otlset.DisplayIdx(foo)
            Exit For
        End If
    Next foo
    Otlset.CurrentLine = 1
    Otlset.SelectIdx = Otlset.TopIdx
    OutlineRefresh OtlPic, OtlScroll, Otlset, OtlDat
Case KEY_END
        Otlset.CurrentLine = Otlset.DisplayCount
        Otlset.SelectIdx = Otlset.DisplayIdx(Otlset.CurrentLine)
    OutlineRefresh OtlPic, OtlScroll, Otlset, OtlDat
    
Case KEY_HOME
        Otlset.CurrentLine = 1
        Otlset.SelectIdx = Otlset.DisplayIdx(Otlset.CurrentLine)
    OutlineRefresh OtlPic, OtlScroll, Otlset, OtlDat

Case KEY_UP
    If Otlset.CurrentLine > 1 Then
        Otlset.CurrentLine = Otlset.CurrentLine - 1
        Otlset.SelectIdx = Otlset.DisplayIdx(Otlset.CurrentLine)
    Else
        For foo = Otlset.TopIdx To 1 Step -1
            If OtlDat(foo).Visible = True Then
                Otlset.TopIdx = foo
                Otlset.SelectIdx = Otlset.TopIdx
                Exit For
            End If
        Next foo
    End If
    OutlineRefresh OtlPic, OtlScroll, Otlset, OtlDat
    
Case KEY_DOWN
    If Otlset.CurrentLine < Otlset.DisplayCount Then
        Otlset.CurrentLine = Otlset.CurrentLine + 1
        Otlset.SelectIdx = Otlset.DisplayIdx(Otlset.CurrentLine)
    Else
        For foo = Otlset.DisplayIdx(Otlset.CurrentLine) + 1 To OtlDat.Count
            If OtlDat(foo).Visible = True Then
                Otlset.TopIdx = Otlset.DisplayIdx(1)
                Otlset.SelectIdx = foo
                Exit For
            End If
        Next foo
    End If
    OutlineRefresh OtlPic, OtlScroll, Otlset, OtlDat

Case Else
End Select
End Sub

'Processes MouseDown to get coordinates of click.

Sub OutlineMouseDown2Line(Otlset As OtlSetup, OtlDat As Collection, y As Single, x As Single)
On Error Resume Next
Otlset.CurrentLine = (y \ Otlset.LineHeight) + 1
Otlset.ElementClicked = (x - OtlDat(Otlset.DisplayIdx(Otlset.CurrentLine)).Level * Otlset.ColWidth) \ Otlset.ColWidth  '0=+/-, 1=Pic, 2=Caption
If Otlset.ElementClicked > 2 Then Otlset.ElementClicked = 2

End Sub


'Setup routine for plus/minus

Sub OutlinePlusMinusSetup(PlusPic As Control, PlusFile As String, MinusPic As Control, MinusFile As String)
On Error Resume Next

Set gPlusPic = PlusPic
Set gMinusPic = MinusPic

If PlusFile > "" Then gPlusPic.Picture = LoadPicture(PlusFile)
If MinusFile > "" Then gMinusPic.Picture = LoadPicture(MinusFile)

End Sub

'This is main drawing routine for outline control.

Sub OutlineRefresh(OtlPic As Control, OtlScroll As Control, Otlset As OtlSetup, OtlDat As Collection)

On Error Resume Next
'Paints control from data array
Dim foo As Integer, foobar As Integer, TotItems As Long
Dim CurrY As Integer, currX As Integer
Dim BmpWidth As Integer, BmpHeight As Integer
Dim TwipsY As Integer, TwipsX As Integer
Dim LineCount As Integer, HoldForeColor As Long
Dim TotVis As Long, SelPnt As Long
ReDim PrevLevelLine(5) As Integer
Dim PrevBmpFile As String
Dim SearchLevel As Integer
If ChangingScroll Then
    Exit Sub 'don't recurse scroll change
End If
TwipsY = Screen.TwipsPerPixelY
TwipsX = Screen.TwipsPerPixelX
'OtlSet.LineHeight = 12 * twipsx
BmpWidth = Otlset.LineHeight
BmpHeight = Otlset.LineHeight
'Just changing select bar?
If Otlset.TopIdx = Otlset.PrevTop And Otlset.VisChangeFlag = False Then
    'OtlPic.AutoRedraw = False
    For foo = 1 To Otlset.DisplayCount
        CurrY = (foo - 1) * Otlset.LineHeight
        If Otlset.DisplayIdx(foo) = Otlset.SelectIdx Then
            OtlPic.CurrentY = CurrY
            currX = OutlineSetX(3, OtlDat(Otlset.DisplayIdx(foo)).Level, Otlset)
            OtlPic.Line (currX, CurrY)-(OtlPic.Width, CurrY + Otlset.LineHeight - TwipsY), Otlset.SelectColor, BF
            Otlset.CurrentLine = foo
            'Print Caption
            OtlPic.CurrentY = CurrY
            OtlPic.CurrentX = currX
            HoldForeColor = OtlPic.ForeColor
            OtlPic.ForeColor = Otlset.SelectTextColor
            OtlPic.Print " " & OtlDat(Otlset.DisplayIdx(foo)).Caption
            OtlPic.ForeColor = HoldForeColor
        Else
            If Otlset.DisplayIdx(foo) = Otlset.PrevSel Then
                OtlPic.CurrentY = CurrY
                currX = OutlineSetX(3, OtlDat(Otlset.DisplayIdx(foo)).Level, Otlset)
                OtlPic.Line (currX, CurrY)-(OtlPic.Width, CurrY + Otlset.LineHeight - TwipsY), OtlPic.BackColor, BF
                'Print Caption
                OtlPic.CurrentY = CurrY
                OtlPic.CurrentX = currX
                OtlPic.Print " " & OtlDat(Otlset.DisplayIdx(foo)).Caption
            End If
        End If
    Next foo
    'OtlPic.AutoRedraw = True
Else
    Erase Otlset.DisplayIdx
    OtlPic.Cls
    'TotItems = UBound(OtlDat)
    TotItems = OtlDat.Count
    LineCount = 1
    For foo = Otlset.TopIdx To TotItems
        If OtlDat(foo).Visible = True Then
            CurrY = (LineCount - 1) * Otlset.LineHeight
            If LineCount = 1 Then
                Otlset.TopIdx = foo
            End If
            Otlset.DisplayIdx(LineCount) = foo
            'Print Select Highlight
            If Otlset.SelectIdx = foo Then
                OtlPic.CurrentY = CurrY
                currX = OutlineSetX(3, OtlDat(foo).Level, Otlset)
                OtlPic.Line (currX, CurrY)-(OtlPic.Width, CurrY + Otlset.LineHeight - TwipsY), Otlset.SelectColor, BF
                Otlset.CurrentLine = LineCount
                HoldForeColor = OtlPic.ForeColor
                'Print Select Caption
                OtlPic.ForeColor = Otlset.SelectTextColor
                OtlPic.CurrentY = CurrY
                OtlPic.CurrentX = currX
                OtlPic.Print " " & OtlDat(foo).Caption
                OtlPic.ForeColor = HoldForeColor
            Else
                'Print Caption
                OtlPic.CurrentY = CurrY
                currX = OutlineSetX(3, OtlDat(foo).Level, Otlset)
                OtlPic.CurrentX = currX
                OtlPic.Print " " & OtlDat(foo).Caption
            End If
            'blt bmp
            If Otlset.BmpFlag = 1 Then
                OtlPic.CurrentY = CurrY
                currX = OutlineSetX(2, OtlDat(foo).Level, Otlset)
                OtlPic.CurrentX = currX
                
                'do bitmap by kind
                'If OtlDat(foo).Level = OtlSet.Levels - 1 Then
                If Not OtlDat(foo).IsParent Then
                    'Leaf
                    If OtlDat(foo).BmpFileName > "" Then
                        Err = 0
                        If PrevBmpFile <> OtlDat(foo).BmpFileName Then
                            gCustomPic.Picture = LoadPicture(OtlDat(foo).BmpFileName)
                            If Err <> 0 Then
                                Err = 0
                                gCustomPic.Picture = LoadPicture(App.Path & "\" & OtlDat(foo).BmpFileName)
                            End If
                            If Err = 0 Then
                                PrevBmpFile = OtlDat(foo).BmpFileName
                            End If
                        End If
                        If Err = 0 Then
                            OtlPic.PaintPicture gCustomPic.Picture, currX, CurrY
                        Else
                            If Otlset.CheckmarkFlag And (OtlDat(foo).Selected = 1) Then
                              OtlPic.PaintPicture gLeafCheckedPic.Picture, currX, CurrY
                            Else
                              OtlPic.PaintPicture gLeafPic.Picture, currX, CurrY
                            End If
                        End If
                    Else
                        If Otlset.CheckmarkFlag And (OtlDat(foo).Selected = 1) Then
                          OtlPic.PaintPicture gLeafCheckedPic.Picture, currX, CurrY
                        Else
                          OtlPic.PaintPicture gLeafPic.Picture, currX, CurrY
                        End If
                    End If
                Else
                    PaintBranchBmp OtlPic, OtlDat(foo).Expanded, OtlDat(foo).Selected, Otlset.CheckmarkFlag, currX, CurrY
                End If
            End If
            'draw lines with default forecolor
            'MOD FOR EXPLORER STYLE DOTTED LINES...
            If Otlset.LineFlag = 1 Then
                PrevLevelLine(OtlDat(foo).Level) = LineCount
                currX = OutlineSetX(0, OtlDat(foo).Level, Otlset)
                DotLine95 OtlPic, currX, CurrY + Otlset.LineHeight \ 2, currX + Otlset.ColWidth * 0.6, CurrY + Otlset.LineHeight \ 2
                If LineCount = 1 Then
                    DotLine95 OtlPic, currX, CurrY + Otlset.LineHeight \ 2, currX, CurrY
                Else
                    If OtlDat(foo - 1).Level = OtlDat(foo).Level Then
                        DotLine95 OtlPic, currX, CurrY + Otlset.LineHeight \ 2, currX, CurrY - Otlset.LineHeight \ 2 '- twipsy
                    Else
                        If OtlDat(foo - 1).Level < OtlDat(foo).Level Then
                            DotLine95 OtlPic, currX, CurrY + Otlset.LineHeight \ 2, currX, CurrY
                        Else
                            For foobar = LineCount - 1 To 1 Step -1
                                If OtlDat(Otlset.DisplayIdx(foobar)).Level <= OtlDat(foo).Level Then
                                    Exit For
                                End If
                            Next foobar
                            If OtlDat(Otlset.DisplayIdx(foobar)).Level <= OtlDat(foo).Level Then
                                DotLine95 OtlPic, currX, CurrY + Otlset.LineHeight \ 2, currX, Otlset.LineHeight * (foobar) - Otlset.LineHeight \ 2
                            Else
                                'Equal level at top or next/any is above limit of control visible area
                                DotLine95 OtlPic, currX, CurrY + Otlset.LineHeight \ 2, currX, 0 'OtlSet.LineHeight * (foobar + 1) - OtlSet.LineHeight \ 2
                            End If
                        End If
                    End If
                End If
            End If
            
            'set next line
            LineCount = LineCount + 1
            If LineCount >= Otlset.DisplayLines Or foo = OtlDat.Count Then
                Exit For
            End If
        End If
    Next foo
    LineCount = LineCount - 1
    Otlset.DisplayCount = LineCount
    'Complete Line processing
    If Otlset.LineFlag = 1 And foo < TotItems Then
        SearchLevel = OtlDat(foo).Level 'Last item displayed
        For foobar = foo + 1 To TotItems
            If OtlDat(foobar).Level <= SearchLevel Then
                currX = OutlineSetX(0, OtlDat(foobar).Level, Otlset)
                DotLine95 OtlPic, currX, OtlPic.Height, currX, PrevLevelLine(OtlDat(foobar).Level) * Otlset.LineHeight  '- twipsy
                SearchLevel = OtlDat(foobar).Level - 1
                If SearchLevel < 0 Then Exit For
            End If
        Next foobar
    End If
    'draw plus minus boxes
    LineCount = 1
    CurrY = 0
    If (Otlset.PlusFlag = 1) Then
      For foo = Otlset.TopIdx To TotItems
        'If (OtlDat(foo).Level < OtlSet.Levels - 1) And OtlDat(foo).Visible Then
        If (OtlDat(foo).IsParent) And OtlDat(foo).Visible Then
            CurrY = (LineCount - 1) * Otlset.LineHeight + Otlset.LineHeight / 2 - Screen.TwipsPerPixelY
            currX = OutlineSetX(1, OtlDat(foo).Level, Otlset)
            OtlPic.CurrentX = currX
            'does the branch have child entries?
            If foo = TotItems Then
                'last entry so no children
                Drawbox Pic:=OtlPic, x:=(currX), y:=(CurrY), Plus:=False
            Else
                'no kids
                If OtlDat(foo + 1).Level <= OtlDat(foo).Level Then
                    Drawbox Pic:=OtlPic, x:=(currX), y:=(CurrY), Plus:=False
                    Else
                    'does have children, but is it expanded already?
                    If OtlDat(foo).Expanded = True Then
                        Drawbox Pic:=OtlPic, x:=(currX), y:=(CurrY), Plus:=False
                    Else 'PLUS - has unexpanded children
                        Drawbox Pic:=OtlPic, x:=(currX), y:=(CurrY), Plus:=True
                    End If
                End If
            End If
        End If
        If OtlDat(foo).Visible Then
            'set next line
            LineCount = LineCount + 1
            If LineCount >= Otlset.DisplayLines Or foo = OtlDat.Count Then
                Exit For
            End If
        End If
      Next foo
    End If
    'Set Scroll Bar
    'Determine visible items
    If Otlset.VisChangeFlag Then
        ChangingScroll = True
        Otlset.VisChangeFlag = False
        Otlset.VisibleItems = -1
        For foo = 1 To TotItems
            If OtlDat(foo).Visible = True Then
                Otlset.VisibleItems = Otlset.VisibleItems + 1
                OtlDat(foo).VisibleIdx = Otlset.VisibleItems
            Else
                OtlDat(foo).VisibleIdx = -1
            End If
        Next foo
        If Otlset.VisibleItems > 0 Then
            OtlScroll.Visible = True
            OtlScroll.Max = Otlset.VisibleItems
        Else
            OtlScroll.Visible = False
            OtlScroll.Value = 0
        End If
        OtlScroll.SmallChange = 1
        OtlScroll.LargeChange = 10
        ChangingScroll = False
    End If
End If
If OtlScroll.Visible = True Then
    ChangingScroll = True
    OtlScroll.Value = OtlDat(Otlset.SelectIdx).VisibleIdx
    ChangingScroll = False
End If
Otlset.PrevSel = Otlset.SelectIdx
Otlset.PrevTop = Otlset.TopIdx

End Sub
Public Sub PaintBranchBmp(OtlPic As Object, Expanded As Integer, Selected As Integer, CheckmarkFlag As Integer, currX As Integer, CurrY As Integer)

If CheckmarkFlag = False Then
  If Expanded Then
    OtlPic.PaintPicture gBranchOpenPic.Picture, currX, CurrY
  Else
    OtlPic.PaintPicture gBranchClosedPic.Picture, currX, CurrY
  End If
Else
  If Expanded Then
    Select Case Selected
    Case 0
      OtlPic.PaintPicture gBranchOpenPic.Picture, currX, CurrY
    Case 1
      OtlPic.PaintPicture gBranchOpenAllPic.Picture, currX, CurrY
    Case 2
      OtlPic.PaintPicture gBranchOpenSomePic.Picture, currX, CurrY
    End Select
  Else
    Select Case Selected
    Case 0
      OtlPic.PaintPicture gBranchClosedPic.Picture, currX, CurrY
    Case 1
      OtlPic.PaintPicture gBranchClosedAllPic.Picture, currX, CurrY
    Case 2
      OtlPic.PaintPicture gBranchClosedSomePic.Picture, currX, CurrY
    End Select
  End If
End If

End Sub
                        
                       

Public Function OutlineSetX(ViewType As Integer, Level As Integer, Otlset As OtlSetup) As Integer
'used for win95 style outlines -- always have bmp, lines, +/-
'ViewType --> 0 = line, 1 = +/- box, 2 = bmp, 3 = text
Dim currX As Integer
Otlset.ColWidth = 17 * Screen.TwipsPerPixelX
Select Case ViewType
Case 0 'lines
  If Level > 0 Then
    currX = Level * Otlset.ColWidth + Otlset.LineHeight \ 2
  Else
    currX = Otlset.LineHeight \ 2
  End If
Case 1 '+/- box
  If Level > 0 Then
    currX = Level * Otlset.ColWidth + Otlset.LineHeight \ 2
  Else
    currX = Otlset.LineHeight \ 2 + Screen.TwipsPerPixelX
  End If
Case 2 'bmp
  If Level > 0 Then
    currX = Level * Otlset.ColWidth + Otlset.ColWidth + Screen.TwipsPerPixelX * 2
  Else
    currX = Otlset.ColWidth + (Screen.TwipsPerPixelX * 2)
  End If
Case 3 'text caption
  If Level > 0 Then
    currX = Level * Otlset.ColWidth + Otlset.ColWidth + Otlset.LineHeight + (Screen.TwipsPerPixelX * 2)
  Else
    currX = Otlset.ColWidth + Otlset.LineHeight + (Screen.TwipsPerPixelX * 2)
  End If
End Select
OutlineSetX = currX
End Function

Sub Drawbox(Pic As Object, x As Long, y As Long, Plus As Integer)
Dim twips As Integer, Holdstyle As Integer
twips = Screen.TwipsPerPixelY
Holdstyle = Pic.DrawStyle

Pic.Line (x - 4 * twips, y - 4 * twips)-Step(8 * twips, 8 * twips), &HFFFFFF, BF
Pic.DrawStyle = 0
Pic.Line (x - 4 * twips, y - 4 * twips)-Step(8 * twips, 8 * twips), &H808080, B
Pic.Line (x - 2 * twips, y)-Step(5 * twips, 0), &H0
If Plus Then Pic.Line (x, y - 2 * twips)-Step(0, 5 * twips), &H0
Pic.DrawStyle = Holdstyle

End Sub



Public Sub DotLine95(OtlPic As Control, x1, y1, x2, y2)
'draws horizontal or vertical only ... no angles in this rev
Dim foo As Integer, LowVal, HighVal, TwipsX As Integer, TwipsY As Integer
Dim OtlPicHdc As Long
Dim Checkit As Long
TwipsX = Screen.TwipsPerPixelX
TwipsY = Screen.TwipsPerPixelY
OtlPicHdc = OtlPic.hDC
If x1 = x2 Then
  If y1 < y2 Then
    LowVal = y1
    HighVal = y2
  Else
    LowVal = y2
    HighVal = y1
  End If
  If (LowVal \ TwipsY) Mod 2 = 1 Then LowVal = (LowVal \ TwipsY) * TwipsY - TwipsY
  If (x1 \ TwipsX) Mod 2 = 1 Then x1 = (x1 \ TwipsX) * TwipsX + TwipsX
  For foo = LowVal To HighVal Step TwipsX * 2
    Checkit = SetPixel(OtlPicHdc, x1 / TwipsX, foo / TwipsY, &H808080)
  Next foo
Else
  If x1 < x2 Then
    LowVal = x1
    HighVal = x2
  Else
    LowVal = x2
    HighVal = x1
  End If
  If (LowVal \ TwipsX) Mod 2 = 1 Then
    LowVal = (LowVal \ TwipsX) * TwipsX + TwipsX
    HighVal = (HighVal \ TwipsX) * TwipsX + TwipsX
  End If
  If (HighVal \ TwipsX) Mod 2 = 1 Then HighVal = (HighVal \ TwipsX) * TwipsX + TwipsX
  If (y1 \ TwipsY) Mod 2 = 1 Then y1 = (y1 \ TwipsY) * TwipsY - TwipsY
  For foo = LowVal To HighVal Step TwipsY * 2
    Checkit = SetPixel(OtlPicHdc, foo / TwipsX, y1 / TwipsY, &H808080)
  Next foo
End If
End Sub


'Used to adjust outline control in response to scroll bar changes.

Sub OutlineScroll(ScrollValue As Integer, OtlPic As Control, OtlScroll As Control, Otlset As OtlSetup, OtlDat As Collection)
Dim foo As Integer, Vispoint As Long
If ChangingScroll Then Exit Sub
Vispoint = -1
If ScrollValue < OtlDat(Otlset.DisplayIdx(1)).VisibleIdx Then
    For foo = Otlset.DisplayIdx(1) To 1 Step -1
        If ScrollValue = OtlDat(foo).VisibleIdx Then
            Otlset.CurrentLine = 1
            Otlset.SelectIdx = foo
            Otlset.TopIdx = Otlset.SelectIdx
            OutlineRefresh OtlPic, OtlScroll, Otlset, OtlDat
            Exit For
        End If
    Next foo
Else
    If ScrollValue > OtlDat(Otlset.DisplayIdx(Otlset.DisplayCount)).VisibleIdx Then
        'find bottom to select
        For foo = Otlset.DisplayIdx(Otlset.DisplayCount) To OtlDat.Count
            If ScrollValue = OtlDat(foo).VisibleIdx Then
                Otlset.CurrentLine = Otlset.DisplayCount
                Otlset.SelectIdx = foo
                Exit For
            End If
        Next foo
        'Find TopIdx for display
        For foo = Otlset.SelectIdx To 1 Step -1
            If OtlDat(foo).VisibleIdx = ScrollValue - Otlset.DisplayCount Then Exit For
        Next foo
        Otlset.TopIdx = foo
        OutlineRefresh OtlPic, OtlScroll, Otlset, OtlDat
    Else
        For foo = 1 To Otlset.DisplayCount
            If OtlDat(Otlset.DisplayIdx(foo)).VisibleIdx = ScrollValue Then
                Otlset.CurrentLine = foo
                Otlset.SelectIdx = Otlset.DisplayIdx(foo)
                OutlineRefresh OtlPic, OtlScroll, Otlset, OtlDat
            End If
        Next foo
    End If
End If
OtlPic.SetFocus
End Sub

'Initializes the parameters for a code-based outline control

Sub OutlineSetup(OtlPic As Control, OtlScroll As Control, Otlset As OtlSetup, DataFields As String, Bmps As Boolean, Lines As Boolean, Plus As Boolean, Checkmarks As Boolean, SelectColor As Long, SelectTextColor As Long, BmpField As String, CheckmarkField As String)
'Initializes the OtlSetup control psuedo-properties
'Note: if using bitmaps for bullets, must have pic loaded for branch open, closed, and leaf
Dim foo As Integer
'Dim VarArr() As String
'ReDim VarArr(0) As String

'OtlScroll.Move OtlPic.ScaleWidth - OtlScroll.Width, 0, OtlScroll.Width, OtlPic.ScaleHeight
OtlScroll.Move OtlPic.Width - OtlScroll.Width, 0, OtlScroll.Width, OtlPic.Height

'removed for test - kdq
'foo = Parse2Array(DataFields, VarArr(), ",")
'DoEvents
'OtlSet.Levels = UBound(VarArr) + 1

'Erase OtlSet.VariableNames()
'For foo = 0 To OtlSet.Levels - 1
'    OtlSet.VariableNames(foo) = Trim$(VarArr(foo))
'Next foo

If BmpField > "" Then Otlset.BmpField = BmpField Else Otlset.BmpField = ""
Otlset.VisChangeFlag = True 'force first count
If Bmps Then Otlset.BmpFlag = 1 Else Otlset.BmpFlag = 0
If Lines Then Otlset.LineFlag = 1 Else Otlset.LineFlag = 0
If Plus Then Otlset.PlusFlag = 1 Else Otlset.PlusFlag = 0
If Checkmarks Then Otlset.CheckmarkFlag = True Else Otlset.CheckmarkFlag = False
Otlset.CheckmarkField = CheckmarkField
Otlset.LineHeight = OtlPic.TextHeight("X") '* 1.1

'If OtlSet.LineHeight Mod Screen.TwipsPerPixelY <> 0 Then OtlSet.LineHeight = (OtlSet.LineHeight \ Screen.TwipsPerPixelY) * Screen.TwipsPerPixelY + Screen.TwipsPerPixelY
Otlset.LineHeight = Otlset.LineHeight + ((Otlset.LineHeight \ Screen.TwipsPerPixelY) Mod 4) * Screen.TwipsPerPixelY

Otlset.DisplayLines = OtlPic.Height \ Otlset.LineHeight
Erase Otlset.DisplayIdx
Otlset.SelectColor = SelectColor
Otlset.SelectTextColor = SelectTextColor
Otlset.TopIdx = 1
Otlset.SelectIdx = 1
Otlset.PrevTop = -1
Otlset.PrevSel = -1

End Sub

'Stretches a picture to a region in Destination

Sub StrBltAllToPoint(Dest As Object, dX As Integer, dY As Integer, dWidth As Integer, dHeight As Integer, Source As Control)
Dim foo As Integer, DestHoldMode As Integer, SrcHoldMode As Integer

DestHoldMode = Dest.ScaleMode
Dest.ScaleMode = 3 'Pixels
SrcHoldMode = Source.ScaleMode
Source.ScaleMode = 3 'Pixels
 
foo = StretchBlt(Dest.hDC, dX, dY, dWidth, dHeight, Source.hDC, 0, 0, Source.ScaleWidth, Source.ScaleHeight, &HCC0020)

Dest.ScaleMode = DestHoldMode
Source.ScaleMode = SrcHoldMode

End Sub

